"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.format = exports.lspFormattingOptionsToJsBeautifyOptions = void 0;
const code_formatter_1 = require("@stylable/code-formatter");
function lspFormattingOptionsToJsBeautifyOptions(// ToDo: check if be private
options) {
    return {
        indent_size: options.tabSize,
        indent_with_tabs: !options.insertSpaces,
        max_preserve_newlines: options.trimFinalNewlines ? 1 : undefined,
        end_with_newline: options.insertFinalNewline,
    };
}
exports.lspFormattingOptionsToJsBeautifyOptions = lspFormattingOptionsToJsBeautifyOptions;
function format(doc, offset, options) {
    const sourceCss = doc.getText();
    let range = { start: doc.positionAt(offset.start), end: doc.positionAt(offset.end) };
    let targetCss = sourceCss;
    if (options.experimental) {
        // ToDo: support range
        range = { start: doc.positionAt(0), end: doc.positionAt(sourceCss.length) };
        targetCss = (0, code_formatter_1.formatDocumentExperimental)(sourceCss, {
            indent: ' '.repeat(options.tabSize || 4),
            endWithNewline: options.endWithNewline,
            wrapLineLength: options.wrapLineLength,
        });
    }
    else {
        targetCss = (0, code_formatter_1.getDocumentFormatting)(sourceCss, offset, lspFormattingOptionsToJsBeautifyOptions(options));
    }
    // ToDo(tech-debt): check against source ranged (currently there are false-positives cases in ranged format)
    return sourceCss === targetCss
        ? []
        : [
            {
                newText: targetCss,
                range,
            },
        ];
}
exports.format = format;
//# sourceMappingURL=formatting.js.map